import java.sql.*;
import java.io.*;
import java.util.*;

class OutEmailDaemon {

    private static long prev_offset;
    private static String prev_time;
    private static String query = 
    	new String("INSERT INTO "+"out_email_log"+" VALUES (");
    private static String temp1, temp;
    private static long period;

    public static void main (String args[])
    throws InterruptedException
    {
        Thread t = Thread.currentThread();
    // sleep for some time initially
	Thread.sleep(1000);
	long start, end, diff;
        while (true) {
	    start = System.currentTimeMillis();
	    try {
		period = Integer.parseInt(args[1]);
    // period must be a positive integer
		if (period <= 0) {
		    throw new NumberFormatException();
		}
    // pass rawlogfile name as parameter to the procedure that inserts tuples
    	        insert_tuples(args[0]);	   
	    }
	    catch (ArrayIndexOutOfBoundsException e) {
		System.err.println
		    ("Usage:java ProxyMainDaemon [rawlogfile] [period]");
		System.exit(1);
    	    }
	    catch (NumberFormatException e) {
		System.err.println
		    ("Usage:java ProxyMainDaemon [rawlogfile] [period]");
		System.err.println("[period] must be greater than zero");
		System.exit(1);
	    }
	    end = System.currentTimeMillis();
    // note that end and start are in milliseconds, where as the period is
    // specified in seconds. Thus we divide by 1000.
	    diff = (end - start)/1000;
    // go into sleep only if the time taken to insert the current batch is less
    // than the period of update. If update time >= period, then no sleep.
    // straight away go into the next batch update.
	    if (diff < period) {
	        long temp = period - diff;
    // the argument taken by sleep is in milliseconds.
	        Thread.sleep(temp*1000); 
	    }
	}
    }

    public static void insert_tuples (String rawlog)
    {
        try 
	{
    // auto commit has been set to false, so an explicit commit stmt is needed
           DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
	    Connection con = DriverManager.getConnection
	    ("jdbc:oracle:thin:@:1521:GEN","ashish","ashish");
	    con.setAutoCommit (false); 
	    Statement stmt = con.createStatement();
	   
	    ResultSet rs = stmt.executeQuery
	    ("SELECT * FROM out_email_offset");
	    rs.next();

	    prev_offset = rs.getInt("prev_offset");
	    prev_time = rs.getString("prev_time");
	    
	    System.out.println (" before : "+ prev_offset);

    // run the perl script proxy to process the raw logfile proxy_log
	    Runtime r = Runtime.getRuntime();
	    Process p = null;
	    System.out.println ("before script");
	    p = r.exec ("./email.sh "+ prev_offset + " " + prev_time+" "+
	    	rawlog+" /tmp/abc2");
	    p.waitFor();
	    System.out.println ("after script");
	    
    // open a stream for input from file
	    FileInputStream infile = new FileInputStream ("/tmp/abc2");
	    InputStreamReader reader = new InputStreamReader (infile);
	    BufferedReader input = new BufferedReader (reader);

    // read from the input file
	    temp = input.readLine();
	    prev_offset = Integer.parseInt(temp);
	    prev_time = input.readLine();

	    infile.close();
	    reader.close();
	    input.close();
	    
	    infile = new FileInputStream ("/tmp/abc3");
	    reader = new InputStreamReader (infile);
	    input = new BufferedReader (reader);

	    temp = input.readLine();
	    while (temp != null)
	    {
		try {
	            temp1 = query + temp + ", ";
	            temp = input.readLine();   // read the local machine name
		    String query1 = "SELECT ip_address FROM ip_machine "+
		        "WHERE machine_name = '" + temp + "'";
		    rs = stmt.executeQuery(query1);
    /* 
    	check if the entry already exists in the database. If it exists, then 
	get the corresponding ip number and use it to insert the log file entry
	in to the database. If the entry does not exist, then use the function
	ipAddress() to get the ipno for that machine. Insert this new value
	into the table which stores the mapping between the ip_nos and the
	machine names. and also use this to insert the new log file entry into
	the database.
    */
		    if (rs.next()) { 
		    	temp1 = temp1+"'" + rs.getString("ip_address") + "')\n";
		    }
		    else {
		    	String ip_no = IPAddress.ipAddress (temp);
		    	stmt.executeUpdate ("INSERT INTO ip_machine VALUES ('" +
		            ip_no + "', '" + temp +"')");
		    	temp1 = temp1 + "'" + ip_no + "')\n";
		    }
		    stmt.executeUpdate(temp1);
		}
		catch (Exception e) {
		    // do nothing
		}
	        temp = input.readLine(); 
	    }
	    stmt.executeUpdate 
	    ("UPDATE out_email_offset set prev_offset = " + prev_offset);
	    stmt.executeUpdate 
	    ("UPDATE out_email_offset set prev_time = " + prev_time);
	    con.commit();  // commit only after updating the offset
	    infile.close();
	    reader.close();
	    input.close();
	}
	catch (ArrayIndexOutOfBoundsException e) {
	    System.out.println ("Usage : rel_name script_name raw_log_file");
	    System.exit (1);
	}
	catch (Exception e)
	{
	    System.out.println (e);
	}
    }
}
