#!/pkgs/local/bin/perl


# this perl program takes 4 arguments on the command line
# [infile]     -- the rawlog file
# [outfile1]   -- the first output file produced by this perl program
# [outfile2]   -- the second output file produced by this perl program
# [offset]     -- the size of the logfile when the update of the database was
# 		  made the last time
# [timestamp]  -- the timestamp associated with the logfile entry last inserted
# 	          into the database


# The program functions as follows :
# open [infile]
# write the size of [infile] to [outfile2]
# compare the size of [infile] with [offset]
# if [offset] > size 
#     seek to the position [offset] from the beginning of the file
#     go to the first character of the log file entry just before this point
#     if the time stamp of the entry at that line is same as [timestamp] 
#     	  process the logfile from that point onwards
#     else { the logfile has been changed }
#     	  process the logfile from the beginning of the file
# else  { the logfile has been changed }
#     process the logfile from the beginning of the file
# write the processed logfile entries to [outfile1] one by one
# write the time stamp of the last log file entry to [outfile2]


# check if the number of arguments is correct or not
if (@ARGV != 5) {
    die ("Usage : proxy [infile] [outfile1] [outfile2] [offset] [timestamp]\n");
}


# open the input and output files
open (INFILE,$ARGV[0]);
open (OUTFILE1,">".$ARGV[1]);


# get the current size of the log-file
$size = -s $ARGV[0];


# if the size of the log file exceeds the [offset], then seek to the offset
# if the offset = 0, then anyway we have to process the logfile from the
# beginning of the file. Note that seek returns 0 if failed
if ($size >= $ARGV[3] && $ARGV[3] != 0) { 
    seek (INFILE,$ARGV[3],0);
    $flag = 1;
    seek (INFILE,-2,1);  # move two characters back in the file
    while ($flag == 1) {
        $inputchar = getc(INFILE); # get the next character in the file
	print ($inputchar);
	if ($inputchar eq "\n") {
	    $flag = 0;	# we have found the previous entry in the log file
	}
	else {
# if the seek over here fails, then it means that there is just one more
# character before this position in the file. Just move one more character back
# in the file and process the file 
            if ((seek(INFILE,-2,1)) == 0) {
	    	seek (INFILE,0,0);
		last;	# break from the loop;
	    }
	}
    }
# now i have reached the beginning of the prev line
    $inputline = <INFILE>;
    print $inputline;
# check if the time stamp is the same. If not, then we need to process the filw
# from the beginning. So, go to the beginning of the file yet again.
    @inarr1 = split (/  */,$inputline);
    if ($inarr1[5] =~ /$ARGV[4]/) == 0) {
        seek (INFILE,0,0);  # seek to the beginning of the file
    }
}

$flag = 0;

# process the input file
$inputline = <INFILE>;
while ($inputline ne "") {
    @inarr = split (/  */,$inputline);
    if ($flag == 0) {
	open (OUTFILE2,">".$ARGV[2]);
	print OUTFILE2 ($size, "\n");
	$flag = 1;
    }
    print OUTFILE1 ($inputline);	
    $inputline = <INFILE>;
} 

# the entries in the [outfile2] are changed only if any new tuples are written
# to the file [outfile1].
if ($flag == 1) {
    $inarr[5] =~ s/\..*$//g;
    print OUTFILE2 ($inarr[5],"\n");
}
