/* 

    To implement the security, when a user submits some form, we get the name
    of that form. We have three levels of security :
     	* general user 
	* non general user (needs to authenticate successfully)
	* root
    The user at any level can submit the forms that can be submitted by those
    at the previous level. Also at every level, some new forms are
    introduced which can't be submitted by anyone from the previous levels.
    Finally, we also take care that no one submits a form with some arbit name
    and gets away.

    Also, if some one submits a form with same name as the ones we are using
    for our forms, then the results he gets will be unexpected. However, this
    does not pose any dangers to the security levels that we are implementing.

 */
import java.io.*;
import java.util.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class m_Servlet extends HttpServlet
{
    Connection con;
    public void init (ServletConfig cfg) 
    throws ServletException {
        try {
	    DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
            con=DriverManager.getConnection
	        ("jdbc:oracle:thin:@:1521:GEN","ashish","ashish");		
	}
	catch (SQLException e){
	    // do nothing
	}
    }

    public void doPost (HttpServletRequest req, HttpServletResponse res) 
    throws ServletException, IOException 
    {
    	res.setContentType("text/html");
	PrintWriter out = res.getWriter();
	HttpSession hs = req.getSession(true);
        m_Session ss = (m_Session)hs.getValue("OurSession");
    // get the form name
	String form_name[] = req.getParameterValues("form_name");
 	if (form_name[0].equals("m_auth_form")) {
    // Mychar is a user-defined class
	    MyChar local_perms = new MyChar ('X');
	    Validator my_validator = new Validator();
	    boolean is_valid = my_validator.validate(req,con,local_perms);
	    if (is_valid) {
    // create a new session
	        ss = new m_Session();  
		hs.putValue("OurSession",ss);
		ss.loginid = req.getParameterValues("loginid")[0];
		ss.perms.val = local_perms.val;
    // print the form which has links for a non general user
    		out.println("login successful <BR>");
		if (ss.perms.val == 'R') {
		    ss.printPage(out,"m_root.html");
		}
		else if (ss.perms.val == 'U') {
		    ss.printPage(out,"m_notgeneral.html");
		} 
		out.close();
	    }
	    else {
    // display a message to convey that the user failed to login properly
		out.println("login incorrect");
		out.close();
	    }
	}
    // if a user who had already validated, again tries to validate but fails
    // we don't khatck his previous valid session. 
    // If he again validates himself again, then we give him a new session, and
    // don't khatch his previous session. It would automatically becom invalid
    // after some time.
        else {
    // the forms that can be submitted by anyone - here we create a new session
    // for the user and then process the form.
	    if (form_name[0].equals("m_general") ||
	    	form_name[0].equals("mc_sending") ||
		form_name[0].equals("mc_receive") ||
		form_name[0].equals("Rmc_sending") || 
		form_name[0].equals ("Rmc_receive") ||
		form_name[0].equals("in_traffic") ||
		form_name[0].equals("out_traffic")||
		form_name[0].equals("sendtime") ||
		form_name[0].equals("rcvtime") ||
		form_name[0].equals("numdef") ||
		form_name[0].equals("mailerr")) 
	    {
		if (ss == null) {
	            m_Session ssgen = new m_Session();  // for a general user
	            ssgen.processForm (out,req,con);
	        }
		else {
		    ss.processForm (out,req,con);  // for an nongeneral user
		}
	    }
    // the forms that can be used by anyone who has authenticated
	    else if (form_name[0].equals("m_notgeneral") ||
	    	      	form_name[0].equals("m_usersentto") ||
	    	      	form_name[0].equals("m_usergotfrom") ||
	    	      	form_name[0].equals("m_topsenders") ||
	    	      	form_name[0].equals("m_topreceivers"))
			
	    {
	        if (ss == null) {
	            out.println("you are not permitted to submit this form3");
		} 
		else {
    	            ss.processForm (out,req,con); 
	 	}
	    }
    // the forms that can be submitted by those who have authenticated as root
	    else if (form_name[0].equals("m_root") ||
		form_name[0].equals("m_rootusersent") ||
		form_name[0].equals("m_rootuserrcv")) 
	    {
	        if (ss == null) {
	            out.println("you are not permitted to submit this form2");
		} else if (ss.perms.val != 'R') {
	            out.println("you are not permitted to submit this form1");
		}
		else {
		    ss.processForm (out,req,con);
		}
	    }
    // this is to take care if someone submits a form with some arbit name
	    else  
	        out.println("you are not permitted to submit this form0");
	}
    }
}
