/*
 
    This class corresponds to a session for a user. 
    The main function is to process the forms submitted in this session.
    SQL queries are made and submitted through a Connection,
    and the result displayed.

*/

import java.util.*;
import java.sql.*;
import javax.servlet.http.*;
import java.io.*;
import javax.servlet.*;

// whenever any error is detected in format of some field, i am throwing an 
// exception of my own

public class m_Session
{
  public String loginid;  // stores the loginid of the user
  MyChar perms = new MyChar ('X');  // stores the permissions of the user
  
  public void processForm (PrintWriter out, HttpServletRequest req,
			   Connection con) 
    {
      try {
	Statement stmt = con.createStatement();
	ResultSet rs, rs1, rs2;
	
	String form_name[] = req.getParameterValues("form_name");
	
	if (form_name[0].equals("m_notgeneral") ||
	    form_name[0].equals("m_general") ||
	    form_name[0].equals("m_root"))
	  {
	    String pressed[] = req.getParameterValues("tofq");
	    printPage(out,pressed[0]);    //display the selected form.
	  }


	else { 
	  String top[] = req.getParameterValues("top");
	  String tofq[] = req.getParameterValues("tofq"); 
	  String machine[] = req.getParameterValues("keywords");
	  //----------------------------------------------------//
	  //    process form 1 top users sending mail (auth)    //
	  //----------------------------------------------------//
	  if (form_name[0].equals("m_topsenders")) {
	    long from = processDate (req,"1");
	    try {
	      if (from == -1)  // check for validity of date1
		throw new MyException();
	    }
	    catch (MyException e) {
	      out.println("you erred");
	      out.close();
	    }
	    long to = processDate (req,"2");
	    try {
	      if (to == -1)  // check for validity of date1
		throw new MyException();
	    }
	    catch (MyException e) {
	      out.println("you erred");
	      out.close();
	    }
	    int topno = Integer.parseInt(top[0]);
	    String result, result2;
	    int count;
	    String query;
		    
		    if (tofq[0].equals("size")){
		      query=
"SELECT * FROM " +
"(SELECT who_login, machine_name, sum(mail_size) AS cnt " +
"FROM out_email_log,ip_machine WHERE st_time BETWEEN " +from+ " AND "+to
+" AND who_mc NOT LIKE '\0\0\0\0' "
+" AND ip_address = who_mc AND machine_name LIKE '%" +machine[0]+ "%' "+
			"GROUP BY who_login, machine_name) ORDER BY cnt DESC";
		    }
		    else {
		      query=

"SELECT * FROM " +
"(SELECT who_login, machine_name, count(*) AS cnt " +
"FROM out_email_log,ip_machine WHERE st_time BETWEEN " +from+ " AND "+to
+" AND who_mc NOT LIKE '\0\0\0\0' "+
" AND ip_address = who_mc AND machine_name LIKE '%" +machine[0]+ "%' "+
			"GROUP BY who_login, machine_name) ORDER BY cnt DESC";
		    }
	    	    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
    	      	        if (rs.next()) {
    			    result = rs.getString("who_login");
			    result2= rs.getString("machine_name");
			    
			    count = rs.getInt("cnt");
			    out.println(count +" " + result+"@"+result2+"<br>");
			    
    	      	        }
    	      	        else {
    	         	    if (i == 0) {
    		     	        out.println("no such user exists");
    		 	    }
    		 	    break;
    	      	        }
	    	    }
	    	    out.close();
	  }
	  
	  	  
	  //-------------------------------------------------------
	  //process form 2 - top users receiving mail (auth)
	  //-------------------------------------------------------
	  if (form_name[0].equals("m_toprecievers")) 
	    {
	      long from = processDate (req,"1");
	      try {
		if (from == -1)  // check for validity of date1
		  throw new MyException();
	      }
	      catch (MyException e) {
		out.println("you erred");
		out.close();
	      }
	      long to = processDate (req,"2");
	      try {
		if (to == -1)  // check for validity of date1
		  throw new MyException();
	      }
	      catch (MyException e) {
		out.println("you erred");
		out.close();
	      }
	      int topno = Integer.parseInt(top[0]);
	      String result, temp;
	      int count;
	      String query;
	      if (tofq[0].equals("size"))
		{
		  query=
		    "SELECT * FROM " +
"(SELECT whom_login, sum(mail_size) AS cnt " +
"FROM in_email_log, ip_machine WHERE end_time BETWEEN " +from+ " AND "+to+
" AND machine_name LIKE '%" +machine[0]+ "%' "+
" AND ip_address = whom_mc AND whom_mc NOT LIKE '\0\0\0\0' "+
  "GROUP BY whom_login) ORDER BY cnt DESC";
		}
	      else
		{ 
		  query =
"SELECT * FROM " +
"(SELECT whom_login, count(*) AS cnt " +
"FROM in_email_log, ip_machine WHERE end_time BETWEEN " +from+ 
" AND "+to+" AND machine_name NOT LIKE '%" +machine[0]+ "%' "+
" AND ip_address = whom_mc AND whom_mc NOT LIKE '\0\0\0\0' "+
  "GROUP BY whom_login,whom_mc) ORDER BY cnt DESC";
		}
 
	      rs = stmt.executeQuery(query);
	      for (int i = 0; i < topno; i++) {
		if (rs.next()) {
		  result = rs.getString("whom_login");
		  count = rs.getInt("cnt");
		  out.println(count +" "+ result);
		}
		else {
		  if (i == 0) {
		    out.println("no such user exists");
		  }
		  break;
		}
	      }
		    
	      out.close();
	    }
	  
		

	  //-------------------------------------------------------
	  // process form #3 - top machines receiving mail (no auth)
	  //-------------------------------------------------------
	  else if (form_name[0].equals("mc_receive")) {
	    long from = processDate (req,"1");
	    try {
	      if (from == -1)  // check for validity of date1
		throw new MyException();
	    }
	    catch (MyException e) {
	      out.println("you erred");
	      out.close();
	    }
	    long to = processDate (req,"2");
	    try {
	      if (to == -1)  // check for validity of date1
		throw new MyException();
	    }
	    catch (MyException e) {
	      out.println("you erred");
	      out.close();
	    }
	    String type1, type2;
	    
	    String query;
	    if (tofq[0].equals("size")) {
	      query=

		"SELECT * FROM " +
" (SELECT machine_name, sum(mail_size) AS cnt " +
" FROM in_email_log, ip_machine WHERE end_time BETWEEN " +from+ " AND "+to+
" AND machine_name LIKE '%" +machine[0]+ "%' "+
" AND ip_address = whom_mc AND whom_mc like '\0\0\0\0' "+
" GROUP BY whom_mc) ORDER BY cnt DESC";
	    }
	    else {
	      query =
		"SELECT * FROM " +
" (SELECT machine_name, count(*) AS cnt " +
" FROM in_email_log, ip_machine WHERE end_time BETWEEN " +from+ " AND "+to+
" AND machine_name LIKE '%" +machine[0]+ "%' "+
" AND ip_address = whom_mc AND whom_mc like '\0\0\0\0' "+
" GROUP BY whom_mc) ORDER BY cnt DESC";
	    }
		    
	    int topno = Integer.parseInt(top[0]);
	    String result, temp;
	    int count;
	    
	    rs = stmt.executeQuery(query);
	    for (int i = 0; i < topno; i++) {
	      if (rs.next()) {
		result = rs.getString("machine_name");
		count = rs.getInt("cnt");
		out.println(count + " " + result+"<BR>");
	      }
	      else {
		if (i == 0) {
		  out.println("no such machine exists");
		}
		break;
	      }
	    }
	    out.close();
	  }
	  
		
		//-------------------------------------------------------
		// process form #4- top machines sending mail (no auth)
		//-------------------------------------------------------
	    	else if (form_name[0].equals("mc_sending")) {
 	    	    long from = processDate (req,"1");
	            try {
	      	    	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String type1, type2;
	    
		    String query;
		    if (tofq[0].equals("size")) {
		      query=

// (SELECT machine_name FROM ip_machine where ip_address = who_mc) AS mach
			/*"SELECT * FROM " +
"(SELECT machine_name, sum(mail_size) AS cnt, " +
"FROM out_email_log, ip_machine WHERE st_time BETWEEN " +from+ " AND "+to+
" AND machine_name LIKE '%" +machine[0]+ "%' "+
" AND ip_address = who_mc AND who_mc NOT LIKE '\0\0\0\0' "+
"GROUP BY machine_name) ORDER BY cnt DESC";*/


"SELECT * FROM (SELECT machine_name, SUM(mail_size) AS cnt FROM " +
"out_email_log, ip_machine WHERE st_time BETWEEN " + from+ " AND "+ to+
" AND machine_name LIKE '%"+machine[0]+"%' AND ip_address = who_mc "+
" AND who_mc NOT LIKE '\0\0\0\0' "+ 
" GROUP BY who_mc, machine_name) ORDER BY cnt DESC";
		      
			}
		    else {
		      query =
			/*"SELECT * FROM " +
"(SELECT machine_name, count(*) AS cnt " +
"FROM out_email_log, ip_machine WHERE st_time BETWEEN " +from+ " AND "+to+
" AND machine_name LIKE '%" +machine[0]+ "%' "+
" AND ip_address = who_mc AND who_mc NOT LIKE '\0\0\0\0' "+
"GROUP BY who_mc) ORDER BY cnt DESC";*/

"SELECT * FROM (SELECT machine_name, COUNT(*) AS cnt FROM " +
"out_email_log, ip_machine WHERE st_time BETWEEN " + from+ " AND "+ to+
" AND machine_name LIKE '%"+machine[0]+"%' AND ip_address = who_mc "+
" AND who_mc NOT LIKE '\0\0\0\0' "+ 
" GROUP BY who_mc, machine_name) ORDER BY cnt DESC";
			}
		    
	    	    int topno = Integer.parseInt(top[0]);
	    	    String result, temp;
		    int count;
		    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
	      		if (rs.next()) {
			    result = rs.getString("machine_name");
			    count = rs.getInt("cnt");
			    out.println(count + " " + result+"<BR>");
	      		}
	      	   	else {
	         	    if (i == 0) {
		     		out.println("no such machine exists");
		 	    }
			    break;
	      		}
	    	    }
	    	    out.close();
	  	}
		
		//-------------------------------------------------------
                // process form #5 - top machines receiving mail (no auth)
		//-------------------------------------------------------
	    	else if (form_name[0].equals("Rmc_receive")) {
 	    	    long from = processDate (req,"1");
	            try {
	      	    	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String type1, type2;
	    
		    String query;
		    if (tofq[0].equals("size")) {
		      query=

"SELECT * FROM " +
"(SELECT whom_mc, sum(mail_size) AS cnt " +
"FROM out_email_log WHERE end_time BETWEEN " +from+ " AND "+to+
" AND whom_mc LIKE '%" +machine[0]+ "%' "+
  "GROUP BY whom_mc) ORDER BY cnt DESC";
			}
		    else {
		      query =
"SELECT * FROM " +
"(SELECT whom_mc, count(*) AS cnt " +
"FROM out_email_log WHERE end_time BETWEEN " +from+ " AND "+to+
" AND whom_mc LIKE '%" +machine[0]+ "%' "+
  "GROUP BY whom_mc) ORDER BY cnt DESC";
			}
	    	    int topno = Integer.parseInt(top[0]);
	    	    String result, temp;
		    int count;
	    
      	    	    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
	      		if (rs.next()) {
			    result = rs.getString("whom_mc");
			    count = rs.getInt("cnt");
			    out.println(count + " " + result+"<BR>");
	      		}
	      	   	else {
	         	    if (i == 0) {
		     		out.println("no such machine exists");
		 	    }
			    break;
	      		}
	    	    }
	    	    out.close();
	  	}
		
		//-------------------------------------------------------
		// process form #6 - top machines from which iitians 
		// receive mail(no auth)
		//-------------------------------------------------------
	    	else if (form_name[0].equals("Rmc_sending")) {
 	    	    long from = processDate (req,"1");
	            try {
	      	    	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String type1, type2;
	    
		    String query;
		    if (tofq[0].equals("size")) {
		      query=

"SELECT * FROM " +
"(SELECT who_mc, sum(mail_size) AS cnt " +
"FROM in_email_log WHERE st_time BETWEEN " +from+ " AND "+to+" AND who_mc LIKE '%" +machine+ "%' "+
  "GROUP BY who_mc) ORDER BY cnt DESC";
			}
		    else {
		      query =
"SELECT * FROM " +
"(SELECT who_mc, count(*) AS cnt " +
"FROM in_email_log WHERE st_time BETWEEN " +from+ " AND "+to+" AND who_mc LIKE '%" +machine+ "%' "+
  "GROUP BY who_mc) ORDER BY cnt DESC";
			}
		    
	    	    int topno = Integer.parseInt(top[0]);
	    	    String result, temp;
		    int count;
	    
      	    	    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
	      		if (rs.next()) {
			    result = rs.getString("who_mc");
			    count = rs.getInt("cnt");
			    out.println(count + " " + result+"<BR>");
	      		}
	      	   	else {
	         	    if (i == 0) {
		     		out.println("no such machine exists");
		 	    }
			    break;
	      		}
	    	    }
	    	    out.close();
	  	}
		


		    //--------------------------------------------
		    // process form #7 - min/max/avg time delay in sending a mail (no auth)
		    //--------------------------------------------------
		else if (form_name[0].equals("sendtime")) {
		  
		    
		  long from = processDate (req,"1");
		  try {
	      	    	if (from == -1)  // check for validity of date1
			  throw new MyException();
		  }
		  catch (MyException e) {
		    out.println("you erred");
		    out.close();
		  }
		  long to = processDate (req,"2");
		  try {
		    if (to == -1)  // check for validity of date1
		      throw new MyException();
		  }
		  catch (MyException e) {
		    out.println("you erred");
		    out.close();
		  }
		  String type1, type2;
	    
		  String query;
		  if (tofq[0].equals("min")) {
		    query=
"SELECT min(end_time - st_time) AS mam " +
  "FROM out_email_log WHERE st_time BETWEEN " +from+ " AND "+to;
		    
		  }
		  else if (tofq[0].equals("max")){
		  query=  "SELECT max(end_time - st_time) AS mam " +
"FROM out_email_log WHERE st_time BETWEEN " +from+ " AND "+to;
		    }
		    else {
		 query=     "SELECT avg(end_time - st_time) AS mam " +
"FROM out_email_log WHERE st_time BETWEEN " +from+ " AND "+to;
		    }
                    int result;
		    int count;
	    
      	    	    rs = stmt.executeQuery(query);
		    
                    if (rs.next()) {
                     result = rs.getInt("mam");
                     out.println("delay is " + result +"s");
                    }
                    else {
		   	out.println("empty table");
		    } 
                    out.close();
	  	}
		

//---------------------------------------------------------------------------
// process form #8 - min/max/avg time delay in receiving mails
//-----------------------------------------------------------------
		  else if (form_name[0].equals("rcvtime")) {
		    
		    
 	    	    long from = processDate (req,"1");
	            try {
	      	    	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    } 
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String type1, type2;
	    
		    String query;
		    if (tofq[0].equals("min")) {
		      query=
"SELECT min(st_time - end_time) AS mam " +
"FROM in_email_log WHERE st_time BETWEEN " +from+ " AND "+to;
			}
		    else if (tofq[0].equals("max")){
		      query ="SELECT max(st_time - end_time) AS mam " +
"FROM in_email_log WHERE st_time BETWEEN " +from+ " AND "+to;
		    }
		    else {
		    query=  "SELECT avg(st_time - end_time) AS mam " +
"FROM in_email_log WHERE st_time BETWEEN " +from+ " AND "+to;
		    }
		    
		    long count;
	    
      	    	    rs = stmt.executeQuery(query);
	      	    if (rs.next()) {
                          count = rs.getInt("mam");
			  out.println("delay =" + count +"s");
			  
                    }
                    else {
		   	out.println("empty table!");
		    }
		    out.close();
		  }
		

    //-------------------------------------------------------------------    
    // process form #9 - min/max/avg deferrals in sending a mail (no auth)
    //------------------------------------------------------------------
		  else if (form_name[0].equals("numdef")) {
		    
		    long from = processDate (req,"1");
	            try {
	      	    	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String type1, type2;
	    
		    String query;
		    if (tofq[0].equals("min")) {
		      query=
"SELECT min(num_deferrals) AS mam " +
"FROM out_email_log WHERE st_time BETWEEN " +from+ " AND "+to;
			}
		    else if (tofq[0].equals("max")){
		   query=   "SELECT max(num_deferrals) AS mam " +
"FROM out_email_log WHERE st_time BETWEEN " +from+ " AND "+to;
		    }
		    else {
		   query=   "SELECT avg(num_deferrals) AS mam " +
"FROM out_email_log WHERE st_time BETWEEN " +from+ " AND "+to;
		    }

		    int count;
	    
      	    	    rs = stmt.executeQuery(query);
	      	    if (rs.next()) {
                          count = rs.getInt("mam");
			  out.println("number of deferrals = " + count);
		    }
                    else {
		   	out.println("empty table!");
		    }
		    out.close();
		  }
		
//-------------------------------------------------------
// process form #10 - errors in mail (no auth)
//-------------------------------------------------------
		  else if (form_name[0].equals("mailerr")) {
		    
		    long from = processDate (req,"1");
	            try {
	      	    	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String whichlog;

                    if (tofq[0].equals("send"))
		      whichlog="out_email_log" ;
                    else 
		      whichlog="in_email_log";
		    
	    
		    String query1, query2;
		    query1=
		      "SELECT COUNT (*) as cnt1"+
		      " FROM "+ whichlog+
		      " WHERE succ_or_fail='F'";
		    
		    query2=
		      "SELECT COUNT(*) cnt2"+
		      " FROM "+ whichlog ;
 

		    int count_fail=0, count_full=1;
		    boolean flag1, flag2;
		    flag1 = false;
		    flag2 = false;
		    rs1 = stmt.executeQuery(query1);
		    if (rs1.next())
		      {
			count_fail = rs1.getInt("cnt1");
			flag1 = true;
		      }
		    
		    rs2 = stmt.executeQuery(query2);
		    if (rs2.next())
		      {
			flag2=true;
			count_full = rs2.getInt("cnt2");
		      }
		    
	      	    if (flag1 && flag2) {
		      out.println( "#failures: " + count_fail + "\n percentage success: " + ((float)(count_full - count_fail)/(float)count_full) * 100 );
                    }
                    else {
		   	out.println("empty table!");
		    }
		    out.close();
		  }
		


		    //------------------------------------------------------	  	    
		    // traffic infow -(no auth)
		    //-------------------------------------------------------
	  
	  	else if (form_name[0].equals("in_traffic")) {
	    	    long from = processDate (req,"1");
	    	    try {
	            	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred ");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String temp,query;
	    	    long max = 0, arr[];
    	    	    arr = new long[20];
    	    	    long from1, to1;
    	    	    long interval = (to - from)/20;
    	    	    for (int i=0; i<20; i++){
    	      		from1=from + i*interval;
	      		to1=from+(i+1)*interval;
                        if (tofq[0].equals("size") )
			  {
			    query = "select" +
			      " SUM(mail_size) AS sum1 FROM in_email_log WHERE st_time BETWEEN "+ from1+" AND "+to1;
			  }
			else
			  {
			    query = "select" +
			      " COUNT(*) AS cnt1 FROM in_email_log WHERE st_time BETWEEN "+ from1+" AND "+to1;
			  }
			
	      		rs = stmt.executeQuery(query);
	      		rs.next();
			if (tofq[0].equals("size") )
			{
			  arr[i] = rs.getInt("sum1");
			}
			      
			else 
			{
			  arr[i] = rs.getInt("cnt1");
			}

				  
			if (max < arr[i])
			  max=arr[i];
		    }
		    
			
	    	    if (max != 0) {
	        	out.print("The specified interval has been divided "+
			"into 20 divisions <BR><BR><BR>");
	    	    }
	    	    for (int i=1; i<=20; i++){
	      	    	if (max == 0) {
	          	    out.println("no traffic in this period");
	            	    break;
	      	    	}
	      	    	arr[i-1]=(int) (arr[i-1]*60)/max;
	      	    	if (i < 10) {
	          	    out.print("&nbsp;&nbsp;"+i+"&nbsp;|");
		    	}
	      	    	else  {
	          	    out.print("&nbsp;"+i+"&nbsp;|");
		    	}
	      	    	for (int j=1; j<=arr[i-1]; j++){
		  	    out.print("#");
	            	}
	      	    	out.println("<BR>");
	    	    } 
	    	    out.close();
	  	}
		

		    //-------------------------------------------------------
		    // out traffic (no auth)
		    //-------------------------------------------------------

	  	else if (form_name[0].equals("out_traffic")) {
	    	    long from = processDate (req,"1");
	    	    try {
	            	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred ");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String temp,query;
	    	    long max = 0, arr[];
    	    	    arr = new long[20];
    	    	    long from1, to1;
    	    	    long interval = (to - from)/20;
    	    	    for (int i=0; i<20; i++){
    	      		from1=from + i*interval;
	      		to1=from+(i+1)*interval;
                        if (tofq[0].equals("size") )
			  {
			    query = "select" +
			      " SUM(mail_size) AS sum1 FROM out_email_log WHERE st_time BETWEEN "+ from1+" AND "+to1;
			  }
			else
			  {
			    query = "select" +
			      " COUNT(*) AS cnt1 FROM out_email_log WHERE st_time BETWEEN "+ from1+" AND "+to1;
			  }
			
	      		rs = stmt.executeQuery(query);
	      		rs.next();
			if (tofq[0].equals("size") )
			{
			  arr[i] = rs.getInt("sum1");
			}
			      
			else 
			{
			  arr[i] = rs.getInt("cnt1");
			}

				  
			if (max < arr[i])
			  max=arr[i];
		    }
		    
			
	    	    if (max != 0) {
	        	out.print("The specified interval has been divided "+
			"into 20 divisions <BR><BR><BR>");
	    	    }
	    	    for (int i=1; i<=20; i++){
	      	    	if (max == 0) {
	          	    out.println("no traffic in this period");
	            	    break;
	      	    	}
	      	    	arr[i-1]=(int) (arr[i-1]*60)/max;
	      	    	if (i < 10) {
	          	    out.print("&nbsp;&nbsp;"+i+"&nbsp;|");
		    	}
	      	    	else  {
	          	    out.print("&nbsp;"+i+"&nbsp;|");
		    	}
	      	    	for (int j=1; j<=arr[i-1]; j++){
		  	    out.print("#");
	            	}
	      	    	out.println("<BR>");
	    	    } 
	    	    out.close();
	  	}
		
		    

		//-------------------------------------------------
	        // top addresses to which i send mail (auth and personal)
	        //-------------------------------------------------

	  else if (form_name[0].equals("m_usersentto")) 
	    {
		    
	      long from = processDate (req,"1");
	      try {
		if (from == -1)  // check for validity of date1
		  throw new MyException();
	      }
	      catch (MyException e) {
		out.println("you erred ");
		out.close();
	      }
	      long to = processDate (req,"2");
	      try {
		if (to == -1)  // check for validity of date1
		  throw new MyException();
	      }
	      catch (MyException e) {
		out.println("you erred");
		out.close();
	      }
	      int topno = Integer.parseInt(top[0]);
	      String result1, result2, temp;
	      int count;
	      String query;
	      if (tofq[0].equals("size"))
		{
		  query =
	    "SELECT whom_login, whom_mc, SUM(mail_size) AS cnt FROM ("+		    " SELECT * FROM out_email_log WHERE who_login ='"+loginid + 
  		   "') GROUP BY whom_login, whom_mc ORDER BY cnt DESC" ;

		}
	      else
		{
		  query = 
		    "SELECT whom_login, whom_mc, COUNT(*) AS cnt "+
			    "FROM "+
			    "( SELECT * "+
			    "FROM out_email_log "+
		    "WHERE who_login ='"+ loginid + "') "+
			    "GROUP BY whom_login, whom_mc "+
			    "ORDER BY cnt DESC";
		}
	      
	      out.println(loginid+" has sent mail to:<BR>");
	      rs = stmt.executeQuery(query);
	      for (int i = 0; i < topno; i++) {
		if (rs.next()) {
		  result1 = rs.getString("whom_login");
		  result2 = rs.getString("whom_mc");
			    count = rs.getInt("cnt");
			    out.println (count+ " " + result1 +"@"+result2 + "<BR>");
		}
		
		else {
		  if (i == 0) {
			      out.println("no such address exists");
		  }
		  break;
		}
	      }
	      
		    
	      out.close();
	    }
	  

		//-------------------------------------------------
	        // root's query about top receivers of a user.
	        //-------------------------------------------------

	  else if (form_name[0].equals("m_rootusersent")) 
	    {
	  String user[] = req.getParameterValues("loginid");		    
	  String compy[] = req.getParameterValues("machine");		    
	      long from = processDate (req,"1");
	      try {
		if (from == -1)  // check for validity of date1
		  throw new MyException();
	      }
	      catch (MyException e) {
		out.println("you erred ");
		out.close();
	      }
	      long to = processDate (req,"2");
	      try {
		if (to == -1)  // check for validity of date1
		  throw new MyException();
	      }
	      catch (MyException e) {
		out.println("you erred");
		out.close();
	      }
	      int topno = Integer.parseInt(top[0]);
	      String result1, result2, temp;
	      int count;
	      String query;
	      if (tofq[0].equals("number"))
		{
		  query = 

		    "SELECT whom_login, whom_mc, COUNT(*) AS cnt FROM "+
"out_email_log, ip_machine WHERE st_time BETWEEN " + from+ " AND "+ to +
" AND who_login='"+ user[0]+"' AND machine_name='"+ compy[0]+"' AND ip_address = who_mc AND "+
		    "who_mc NOT LIKE '\0\0\0\0' GROUP BY whom_login, whom_mc ORDER BY cnt DESC";
		  
		}
	      

	      else
		{
		  

		  query=  "SELECT whom_login, whom_mc, SUM(mail_sizeOB) AS cnt FROM "+
"out_email_log, ip_machine WHERE st_time BETWEEN " + from+ " AND "+ to +
" AND who_login='"+ user[0]+"' AND machine_name='"+ compy[0]+"' AND ip_address = who_mc AND "+
		    "who_mc NOT LIKE '\0\0\0\0' GROUP BY whom_login, whom_mc ORDER BY cnt DESC";

		}
	      
	      out.println(user[0]+"@"+compy[0]+"<BR>");
	      rs = stmt.executeQuery(query);
	      for (int i = 0; i < topno; i++) {
		if (rs.next()) {
		  result1 = rs.getString("whom_login");
		  result2 = rs.getString("whom_mc");
			    count = rs.getInt("cnt");
			    out.println (count+ " to " + result1 +"@"+result2+ "<BR>");
		}
		
		else {
		  if (i == 0) {
			      out.println("no such address exists");
		  }
		  break;
		}
	      }
	      
		    
	      out.close();
	    }

	  //-----------------------------------------------------
	  //root's query about mails received by a specific user
	  //-----------------------------------------------------
	  else if (form_name[0].equals("m_rootuserrcv")) 
	    {
	  String user[] = req.getParameterValues("loginid");		    
	  String compy[] = req.getParameterValues("machine");		    
	      long from = processDate (req,"1");
	      try {
		if (from == -1)  // check for validity of date1
		  throw new MyException();
	      }
	      catch (MyException e) {
		out.println("you erred ");
		out.close();
	      }
	      long to = processDate (req,"2");
	      try {
		if (to == -1)  // check for validity of date1
		  throw new MyException();
	      }
	      catch (MyException e) {
		out.println("you erred");
		out.close();
	      }
	      int topno = Integer.parseInt(top[0]);
	      String result1, result2, temp;
	      int count;
	      String query;
	      if (tofq[0].equals("number"))
		{
		  query = 
"SELECT * from" +
"(SELECT who_login,who_mc,COUNT(*) AS cnt FROM in_email_log"+
"WHERE whom LIKE'%"+user+"%' AND whom_mc LIKE'%"+compy+"%)"+
"ORDER BY cnt DESC";


		}
	      else
		{
		  query = 
"SELECT * from" +
"(SELECT who_login,who_mc,SUM(mail_size)as cnt FROM out_email_log"+
"WHERE whom LIKE'%"+user+"%' AND whom_mc LIKE'%"+compy+"%)"+
"ORDER BY cnt DESC";  

		}
	      
	      out.println(user+"@"+compy+"<BR>");
	      rs = stmt.executeQuery(query);
	      for (int i = 0; i < topno; i++) {
		if (rs.next()) {
		  result1 = rs.getString("who_login");
		  result2 = rs.getString("who_mc");
			    count = rs.getInt("cnt");
			    out.println (count+ " " + result1 +"@"+result2);
		}
		
		else {
		  if (i == 0) {
			      out.println("no such address exists");
		  }
		  break;
		}
	      }
	      
		    
	      out.close();
	    }	  

	}
	
      }
      
	catch (MyException e) {
    	    out.println("you erred3 ");
    	    out.println(e);
  	}
	catch (Exception e) {
	    out.println("you erred4 ");
	    out.println(e);
	}
	finally {
	  out.close();
	}

	
    }
  
  
    public long processDate (HttpServletRequest req, String s)
    throws MyException
    {
	DateVerify dv = new DateVerify();
	String date []= req.getParameterValues("d"+s);
	String month[] = req.getParameterValues("m"+s);
	String year[] = req.getParameterValues("y"+s);
	String hour[] = req.getParameterValues("h"+s);
	String min[] = req.getParameterValues("mn"+s);
	
	try {
	    String submit[] = {date[0],month[0],year[0],hour[0],min[0]};
	    return dv.dateVerifier(submit)/1000;
	}
	catch (ArrayIndexOutOfBoundsException e) {
	    throw new MyException();
	}
    }

/* 
   the method takes a file name as an argument and prints that file on the
   user's page. Only the name of the file is passed. The path of the file is
   assumed to be /users/ug96/ashish/public_html/ at present.
*/

    public void printPage (PrintWriter out, String filename) {
        final String path = "/users/ug96/ashish/public_html/";
        try {
	    FileInputStream infile = new FileInputStream (path+filename);
	    InputStreamReader reader = new InputStreamReader (infile);
	    BufferedReader input = new BufferedReader (reader);

	    String temp;
	    temp = input.readLine();
	    while (temp != null)   // read till the end of file
	    {
	        out.println(temp);
		temp = input.readLine();
	    }
	    infile.close();
	    reader.close();
	    input.close();
	    out.close();
	}
	catch (Exception e) {
   	    out.println (e+" in pageprint");  // error checking message 
	}
    }
}
